#coding:utf-8
import wave
import numpy as np
import scipy.fftpack
from pylab import *

if __name__ == "__main__" :
    wf = wave.open("bell_data/bell1.wav" , "r" )
    fs = wf.getframerate()  # サンプリング周波数
    num= wf.getnframes()
    x = wf.readframes(num)
    x = frombuffer(x, dtype= "int16") / 32768.0  # -1 - +1に正規化

    print ("Channel num : {0}".format(wf.getnchannels()))
    print ("Sample size : {0}".format(wf.getsampwidth()))
    print ("Sampling rate : {0}".format(wf.getframerate()))
    print ("Frame num : {0}".format(wf.getnframes()))
    print ("Sec : {0}".format(float(wf.getnframes()) / wf.getframerate()))
    wf.close()

    start = 0  # サンプリングする開始位置
    N = 5000  # FFTのサンプル数
    X = np.fft.fft(x[start:start+N])  # FFT
    freqList = np.fft.fftfreq(N, d=1.0/fs)  # 周波数軸の値を計算
    amplitudeSpectrum = [np.sqrt(c.real ** 2 + c.imag ** 2) for c in X]  # 振幅スペクトル
    
    freq1=2500
    amax=1
    smax = 40

    # 波形を描画
    subplot(311)  # 3行1列のグラフの1番目の位置にプロット
    plot(range(start, start+N), x[start:start+N])
    axis([start, start+N, -amax, amax])
    xlabel("time [sample] < C >")
    ylabel("amplitude")

    # 振幅スペクトルを描画
    subplot(313)
    plot(freqList, amplitudeSpectrum)
    axis([0, freq1, 0, smax])
    xlabel("frequency [Hz]")
    ylabel("amplitude spectrum")

    show()
